// Asian Rivers
// a random map for AOE3: TAD
// by RF_Gandalf

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{  
   // Text
   rmSetStatusText("",0.01);

// Set up for variables
   string baseType = "";
   string patchMixType = "";
   string cliffType = "";
   string forestType = "";
   string forest2Type = "";
   string riverType = "";
   string treeType = "";
   string deerType = "";
   string deer2Type = "";
   string sheepType = "";
   string centerHerdType = "";
   string mineType = "";
   string native1Name = "";
   string native2Name = "";

// Pick pattern for trees, terrain, features, etc.
   int patternChance = rmRandInt(29,36); 
   int variantChance = rmRandInt(1,2);
   int lightingChance = rmRandInt(1,2);
   int socketPattern = rmRandInt(1,2);   
   int nativeSetup = rmRandInt(0,17);
   if (cNumberNonGaiaPlayers > 6)
   {
	if (nativeSetup == 9)
         nativeSetup = rmRandInt(11,17);
	if (nativeSetup == 10)
         nativeSetup = rmRandInt(0,8);
   }	 
   int nativePattern = -1;
   int nativeNumber = rmRandInt(2,6);
   int endPosition = rmRandInt(1,3);
   int sidePosition = rmRandInt(1,3);
   int sheepChance = rmRandInt(1,2);
   int cliffChance = rmRandInt(1,10);
   int makeCliffs = -1; 
   if (cliffChance > 5)  
      makeCliffs = 1;
   int cliffVariety = rmRandInt(1,4);
   int eagles = -1;
   int kingfishers = -1;
   int placeBerries = 1;
   int forestDist = rmRandInt(12,18);
   int axisChance = 1;
   int playerSide = rmRandInt(1,2);   
   int twoChoice = rmRandInt(1,2);
   int threeChoice = rmRandInt(1,3);
   int fourChoice = rmRandInt(1,4);
   int placeGold = rmRandInt(1,5);
   int makePatchMix = -1;
   int mineChance = rmRandInt(1,10);
   int dualForest = 0;
   int KOTHposition = rmRandInt(1,2);

// Picks the map size
   int playerTiles = 20000;
   if (cNumberNonGaiaPlayers == 8)
	playerTiles = 14000;
   else if (cNumberNonGaiaPlayers == 7)
	playerTiles = 14500;
   else if (cNumberNonGaiaPlayers == 6)
	playerTiles = 15750;
   else if (cNumberNonGaiaPlayers == 5)
	playerTiles = 16500;
   else if (cNumberNonGaiaPlayers == 4)
	playerTiles = 17500;
   else if (cNumberNonGaiaPlayers == 3)
	playerTiles = 18500;

   int size=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
   int longSide=1.65*size;  
   rmSetMapSize(longSide, size);
   
// Elevation
   int elevationChance = rmRandInt(1,4);
  // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
   if (elevationChance == 1)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	rmSetMapElevationHeightBlend(1.0);
   }
   else if (elevationChance == 2)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.02, 3, 0.5, 8.0);
	rmSetMapElevationHeightBlend(1.0);
   }  
   else if (elevationChance == 3)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.1, 5, 0.2, 5.0);
	rmSetMapElevationHeightBlend(0.9);
   }
   else if (elevationChance == 4)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0);
	rmSetMapElevationHeightBlend(0.8);
   }
   rmSetSeaLevel(0.0);
	
   // Text
   rmSetStatusText("",0.05);

// Pick terrain patterns and features 

   if (mineChance == 10)
	mineType = "minegold";
   else if (mineChance < 4)
	mineType = "mine"; 
   else if (mineChance < 7)
	mineType = "mineCopper"; 
   else 
	mineType = "mineTin";   

   if (patternChance == 29) // HONSHU  
   {   
      rmSetMapType("Japan");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Honshu");
	else
	   rmSetLightingSet("new england");
      baseType = "coastal_japan_a";
      patchMixType = "coastal_japan_c";
	forestType = "Coastal Japan Forest";
	if (rmRandInt(1,2) == 1)
	   riverType = "Andes River";
	else
	   riverType = "Amazon River";
      cliffType = "Coastal Japan";
	treeType = "ypTreeJapaneseMaple";
      if (variantChance == 1)
	{
         deerType = "ypSerow";
         deer2Type = "ypGiantSalamander";
         centerHerdType = "ypSerow";         
	}
      else 
	{     
         deerType = "ypSerow";
         deer2Type = "ypSerow";
         centerHerdType = "ypGiantSalamander";        
	}
      if (sheepChance == 1)
         sheepType = "ypWaterBuffalo";
      else
         sheepType = "ypGoat";
	makePatchMix = 1;
      nativePattern = 44;
	kingfishers = 1;
   }
   else if (patternChance == 30) // DECCAN
   {   
      rmSetMapType("deccan");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("deccan");
	else
	   rmSetLightingSet("texas");
	if (twoChoice == 1)
	{
         baseType = "deccan_grassy_Dirt_a";
	   patchMixType = "deccan_grass_a";
         cliffType = "Deccan Plateau";
	}
	else
	{
         baseType = "deccan_grass_a";
	   patchMixType = "deccan_grassy_Dirt_a";
         cliffType = "Deccan Plateau River";
	} 
	if (threeChoice == 1)
	{
 	   forestType = "Ashoka Forest";
	   forest2Type = "Deccan Forest";
   	   treeType = "ypTreeAshoka";
	   if (rmRandInt(1,2) == 1)
	      dualForest = 1;
	}
	else if (threeChoice == 2)
	{
 	   forestType = "Eucalyptus Forest";
	   forest2Type = "Deccan Forest";
   	   treeType = "ypTreeEucalyptus";
	   if (rmRandInt(1,2) == 1)
	      dualForest = 1;
	}
	else
	{
	   forestType = "Deccan Forest";
   	   treeType = "ypTreeDeccan";
	}
	riverType = "Deccan Plateau River";
      if (variantChance == 1)
	{
         deerType = "ypNilgai";
         deer2Type = "ypWildElephant";
         centerHerdType = "ypNilgai";         
	}
      else 
	{     
         deerType = "ypNilgai";
         deer2Type = "ypNilgai";
         centerHerdType = "ypWildElephant";        
	}
      if (sheepChance == 1)
         sheepType = "ypWaterBuffalo";
      else
         sheepType = "ypGoat";
	makePatchMix = 1;
	if (threeChoice == 1)
         nativePattern = 45;
	else if (threeChoice == 2)
         nativePattern = 46;
	else if (threeChoice == 3)
         nativePattern = 47;
	kingfishers = 1;
   }
   else if (patternChance == 31) // HIMALAYAS
   {   
      rmSetMapType("himalayas");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Himalayas");
	else
	   rmSetLightingSet("Yukon");
      baseType = "himalayas_a";
      patchMixType = "himalayas_b";
	forestType = "Himalayas Forest";
	riverType = "Yukon River";
      cliffType = "himalayas";
	treeType = "ypTreeHimalayas";
      if (variantChance == 1)
	{
         deerType = "ypIbex";
         deer2Type = "ypMarcoPoloSheep";
         centerHerdType = "ypIbex";         
	}
      else 
	{     
         deerType = "ypMarcoPoloSheep";
         deer2Type = "ypIbex";
         centerHerdType = "ypSerow";        
	}
      sheepType = "ypYak";
	if (rmRandInt(1,2) == 1)
         placeBerries = 0;
	makePatchMix = 1;
      nativePattern = 49;
	eagles = 1;
	cliffVariety = 10;
   }
   else if (patternChance == 32) // INDOCHINA-BORNEO
   {   
      rmSetMapType("borneo");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("borneo");
	else
	   rmSetLightingSet("bayou");
      baseType = "borneo_grass_a";
	if (rmRandInt(1,2) == 1)
         patchMixType = "borneo_underbrush";
	else
         patchMixType = "borneo_sand_a";
	if (fourChoice == 1)
	{
	   forestType = "Borneo Palm Forest";
	   forest2Type = "Borneo Canopy Forest";
	   dualForest = 1;
	}
	else if (fourChoice == 2)
	{
	   forestType = "Borneo Palm Forest";
	}
	else if (fourChoice == 3)
	{
	   forestType = "Borneo Canopy Forest";
	}
	else
	   forestType = "Borneo Forest";
	cliffType = "California";  
	riverType = "Borneo Water";
	treeType = "ypTreeBorneo";
      if (variantChance == 1)
	{
         deerType = "ypSerow";
         deer2Type = "ypSerow";
         centerHerdType = "ypWildElephant";         
	}
      else 
	{     
         deerType = "ypSerow";
         deer2Type = "ypWildElephant";
         centerHerdType = "ypSerow";        
	}
      sheepType = "ypWaterBuffalo";
      makePatchMix = 1;
      nativePattern = 48;
	kingfishers = 1;
   }
   else if (patternChance == 33) // MONGOLIA
   {   
      rmSetMapType("mongolia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Mongolia");
	else
	   rmSetLightingSet("Pampas");
	riverType = "Andes River";
	if (twoChoice == 1)
	{
         baseType = "mongolia_grass_b";
         patchMixType = "mongolia_grass";
	   forestType = "Mongolian Forest";
	   treeType = "ypTreeMongolianFir";
	}
	else
	{
         baseType = "mongolia_desert";
         patchMixType = "mongolia_grass_b";
	   forestType = "Saxaul Forest";
         treeType = "ypTreeSaxaul";
	}
      if (variantChance == 1)
	{
         deerType = "ypSaiga";
         deer2Type = "ypMarcoPoloSheep";
         centerHerdType = "ypSaiga";         
	}
      else 
	{     
         deerType = "ypMarcoPoloSheep";
         deer2Type = "ypSaiga";
         centerHerdType = "ypSaiga";        
	}
      sheepType = "ypYak";
	makePatchMix = 1;
      makeCliffs = 0;
      nativePattern = 50;
	eagles = 1;
   }
   else if (patternChance == 34) // YELLOW RIVER 
   {   
      rmSetMapType("yellowRiver");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("yellow_river_dry");
	else
	   rmSetLightingSet("Great Lakes");
      baseType = "yellow_river_a";
      patchMixType = "yellow_river_b";
	dualForest = 1;
	if (twoChoice == 1)
	{
 	  forestType = "Yellow River Forest";
	  forest2Type = "Bamboo Forest";
   	  treeType = "ypTreeBamboo";
	}
	else
	{
 	  forestType = "Yellow River Forest";
	  forest2Type = "Ginkgo Forest";
   	  treeType = "ypTreeGinkgo";
	}
      riverType = "Yellow River";
      cliffType = "Yellow River";
      if (variantChance == 1)
	{
         deerType = "ypSerow";
         deer2Type = "ypMarcoPoloSheep";
         centerHerdType = "ypMuskDeer";         
	}
      else 
	{     
         deerType = "ypSerow";
         deer2Type = "ypMuskDeer";
         centerHerdType = "ypMarcoPoloSheep";        
	}
      if (sheepChance == 1)
         sheepType = "ypWaterBuffalo";
      else
         sheepType = "ypGoat";
	makePatchMix = 1;
      nativePattern = 52;
	kingfishers = 1;
   }
   else if (patternChance == 35) // SIBERIA  
   {   
      rmSetMapType("siberia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("siberia");
	else
	   rmSetLightingSet("yukon");
      baseType = "rockies_grass_snowb";
      patchMixType = "rockies_snow";
	forestType = "Yukon Snow Forest";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	treeType = "TreeYukonSnow";
      if (variantChance == 1)
	{
         deerType = "ypMuskDeer";
         deer2Type = "ypSaiga";
         centerHerdType = "ypSaiga";         
	}
      else 
	{     
         deerType = "ypSaiga";
         deer2Type = "ypMuskDeer";
         centerHerdType = "ypSaiga";        
	}
      sheepType = "ypYak";
      placeBerries = 0;
	makePatchMix = 1;
      nativePattern = 53;
	eagles = 1;
   }
   else if (patternChance == 36) // GREEN SIBERIA  
   {
      rmSetMapType("mongolia");
      rmSetMapType("grass");
	if (lightingChance == 2)
	   rmSetLightingSet("nwterritory");
	else
         rmSetLightingSet("saguenay");
      baseType = "nwt_grass1";
      forestType = "NW Territory Forest";
      treeType = "TreeGreatPlains";   
	riverType = "Northwest Territory Water";
	cliffType = "Araucania Central";    
      if (variantChance == 1)
	{
         deerType = "ypMuskDeer";
         deer2Type = "ypSaiga";
         centerHerdType = "ypSaiga";         
	}
      else 
	{     
         deerType = "ypSaiga";
         deer2Type = "ypMuskDeer";
         centerHerdType = "ypSaiga";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "ypGoat"; 
      eagles = 1;
	if (twoChoice == 1)
         nativePattern = 52;
	else 
         nativePattern = 54;
   }

// Native patterns
   if (nativePattern == 44)
   {
      rmSetSubCiv(0, "zen");
      native1Name = "native zen temple cj 0";
      rmSetSubCiv(1, "jesuit");
      native2Name = "native jesuit mission cj 0";
   }
   else if (nativePattern == 45)
   {
      rmSetSubCiv(0, "udasi");
      native1Name = "native udasi village ";
      rmSetSubCiv(1, "bhakti");
      native2Name = "native bhakti village ";
   }
   else if (nativePattern == 46)
   {
      rmSetSubCiv(0, "sufi");
      native1Name = "native sufi mosque deccan ";
      rmSetSubCiv(1, "bhakti");
      native2Name = "native bhakti village ";
   }
   else if (nativePattern == 47)
   {
      rmSetSubCiv(0, "udasi");
      native1Name = "native udasi village ";
      rmSetSubCiv(1, "sufi");
      native2Name = "native sufi mosque deccan ";
   }
   else if (nativePattern == 48)
   {
      rmSetSubCiv(0, "sufi");
      native1Name = "native sufi mosque borneo ";
      rmSetSubCiv(1, "jesuit");
      native2Name = "native jesuit mission borneo 0";
   }
   else if (nativePattern == 49)
   {
      rmSetSubCiv(0, "udasi");
      native1Name = "native udasi village himal ";
      rmSetSubCiv(1, "bhakti");
      native2Name = "native bhakti village himal ";
   }
   else if (nativePattern == 50)
   {
      rmSetSubCiv(0, "sufi");
      native1Name = "native sufi mosque mongol ";
      rmSetSubCiv(1, "shaolin");
      native2Name = "native shaolin temple mongol 0";
   }
   else if (nativePattern == 51)
   {
      rmSetSubCiv(0, "zen");
      native1Name = "native zen temple ceylon 0";
      rmSetSubCiv(1, "bhakti");
      native2Name = "native bhakti village ceylon ";
   }
   else if (nativePattern == 52)
   {
      rmSetSubCiv(0, "zen");
      native1Name = "native zen temple YR 0";
      rmSetSubCiv(1, "shaolin");
      native2Name = "native shaolin temple YR 0";
   }
   else if (nativePattern == 53)
   {
      rmSetSubCiv(0, "shaolin");
      native1Name = "native shaolin temple mongol 0";
      rmSetSubCiv(1, "shaolin");
      native2Name = "native shaolin temple mongol 0";
   }
   else if (nativePattern == 54)
   {
      rmSetSubCiv(0, "shaolin");
      native1Name = "native shaolin temple YR 0";
      rmSetSubCiv(1, "jesuit");
      native2Name = "native jesuit mission borneo 0";
   }

// Other starting parameters
   rmSetBaseTerrainMix(baseType);
   rmTerrainInitialize("yukon\ground1_yuk", 1);
   rmEnableLocalWater(false);
   rmSetMapType("land");
   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(2.0);
   chooseMercs();

// Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classPatch");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("center");
   rmDefineClass("classNugget");
   rmDefineClass("socketClass");
   rmDefineClass("classCliff");
   int classHuntable=rmDefineClass("huntableFood");   
   int classHerdable=rmDefineClass("herdableFood"); 
   int classProp=rmDefineClass("allProps");

   // Text
   rmSetStatusText("",0.10);

// -------------Define constraints
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int secondEdgeConstraint=rmCreateBoxConstraint("avoid edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);

   // Center constraints
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
   int centerConstraintShort=rmCreateClassDistanceConstraint("stay away from center short", rmClassID("center"), 12.0);
   int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 50.0);

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 40.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 25.0);
   int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 60.0);
   int farPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players more", classPlayer, 85.0);
   int fartherPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players the most", classPlayer, 105.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0); 

   // Nature avoidance
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int shortForestConstraint=rmCreateClassDistanceConstraint("patch vs. forest", rmClassID("classForest"), 15.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), forestDist);
   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
   int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidSheep=rmCreateClassDistanceConstraint("sheep avoids sheep etc", rmClassID("herdableFood"), 35.0);
   int huntableConstraint=rmCreateClassDistanceConstraint("huntable constraint", rmClassID("huntableFood"), 35.0);
   int longHuntableConstraint=rmCreateClassDistanceConstraint("long huntable constraint", rmClassID("huntableFood"), 55.0);
   int forestsAvoidBison=rmCreateClassDistanceConstraint("forest avoids bison", rmClassID("huntableFood"), 15.0);

   // Avoid impassable land, certain features
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 18.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 8.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
   int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water mid-longer", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water a little more", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 30.0);
  
   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 7.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 60.0);
   int avoidNativesMed=rmCreateClassDistanceConstraint("stuff avoids natives medium", rmClassID("natives"), 35.0);
   int avoidNativesShort=rmCreateClassDistanceConstraint("stuff avoids natives shorter", rmClassID("natives"), 15.0);
   int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("classNugget"), 42.0);
   int avoidNuggetMed=rmCreateClassDistanceConstraint("nugget vs. nugget med", rmClassID("classNugget"), 50.0);
   int avoidNuggetLong=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 70.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
   int avoidAllProps=rmCreateClassDistanceConstraint("props avoid each other", rmClassID("allProps"), 65.0);
   int avoidKOTH=rmCreateTypeDistanceConstraint("avoid KOTH", "ypKingsHill", 8.0);

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
   int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
   int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 10.0);

// ---------------------------------------------------------------------------------------

   // Text
   rmSetStatusText("",0.15);

// Set up player starting locations
if (cNumberTeams == 2)
{
   if (cNumberNonGaiaPlayers == 2)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.22, 0.23);
	   }
	   else
	   {
            rmSetPlacementSection(0.77, 0.78);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.27, 0.28);
	   }
	   else
	   {
            rmSetPlacementSection(0.72, 0.73);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
   }
   else if (cNumberNonGaiaPlayers < 5)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
   }
   else if (cNumberNonGaiaPlayers < 7)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);
   }
   else
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);
   }
}
else if (cNumberTeams > 2)
   rmPlacePlayersSquare(0.38, 0.0, 0.0);

   // Text
   rmSetStatusText("",0.20);
	
// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(120);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, avoidWater20); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, baseType);
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();

   // Text
   rmSetStatusText("",0.25);

// Rivers
      int riverWidthChance = rmRandInt(1,3);
      int rivermin = -1;
      int rivermax = -1;
      int shallowPattern = rmRandInt(1,6);

      if (riverWidthChance == 1)
      {
	   rivermin = 8;
	   rivermax = 10;
      }
      else if (riverWidthChance == 2)
      {
         rivermin = 9;
	   rivermax = 11;
      }
      else
      {
         rivermin = 11;
	   rivermax = 13;
      }

	int singleRiver = rmRiverCreate(-1, riverType, 30, 10, rivermin, rivermax); 
      rmRiverSetConnections(singleRiver, 0.35, 0.0, 0.35, 1.0);

	if (shallowPattern == 6) // single larger centered 
	{
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(16, 22));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.28, 0.33));
	}
	else
	{
	 if (shallowPattern < 3) // .4 and .6 crossings for 1 and 2
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.2, 0.22)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.39, 0.41));
	 }
	 if (shallowPattern < 4) // end crossings, for 2-3
	 {
	   if (shallowPattern >1)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.04, 0.06)); 

	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.53, 0.55));
	   }
	 }
	 if (shallowPattern > 3) // end crossings for 4, 5
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.07, 0.1)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.5, 0.54));
	 }
	 if (shallowPattern > 2) // center for patterns 3, 4
	 {
	   if (shallowPattern < 5)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.29, 0.32));
	   }
	 }
	}
	rmRiverSetBankNoiseParams(singleRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0); 
	rmRiverBuild(singleRiver);

	int secondRiver = rmRiverCreate(-1, riverType, 30, 10, rivermin, rivermax); 
      rmRiverSetConnections(secondRiver, 0.65, 0.0, 0.65, 1.0);

	if (shallowPattern == 6) // single larger centered 
	{
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(16, 22));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.28, 0.33));
	}
	else
	{
	 if (shallowPattern < 3) // .4 and .6 crossings for 1 and 2
	 {	
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.2, 0.22)); 

	   rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.39, 0.41));
	 }
	 if (shallowPattern < 4) // end crossings, for 2-3
	 {
	   if (shallowPattern >1)
	   {	
	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.04, 0.06)); 

	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.5, 0.54));
	   }
	 }
	 if (shallowPattern > 3) // end crossings for 4, 5
	 {	
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.07, 0.1)); 

	   rmRiverSetShallowRadius(secondRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.5, 0.54));
	 }
	 if (shallowPattern > 2) // center for patterns 3, 4
	 {
	   if (shallowPattern < 5)
	   {	
	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.29, 0.32));
	   }
	 }
	}
	rmRiverSetBankNoiseParams(secondRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0); 
	rmRiverBuild(secondRiver);

   // Text
   rmSetStatusText("",0.30);

// Trade Routes
   variantChance = rmRandInt(1,2);

   // center route 
   int tradeRouteID6 = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.17);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.2);
   if(rmGetIsKOTH())
   {
	if (KOTHposition == 1)
	{
   	   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.38);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.48);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.52);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.62);
	}
	else
	{
   	   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.38);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.48);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.52);
         rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.62);
	}
   }
   else
   {
      rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.35);
      rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.48);
      rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.52);
      rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.65);
   }
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.8);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.83);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 1.0);
   rmBuildTradeRoute(tradeRouteID6, "water");	

   // End Trade Routes
   // west route
   int tradeRouteID7 = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.12, 0.11);	
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.09, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.075, 0.35);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.06, 0.4);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.055, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.055, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.06, 0.6);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.075, 0.65);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.09, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.12, 0.89);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 1.0);
   rmBuildTradeRoute(tradeRouteID7, "water");

   // east route
   int tradeRouteID7A = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.88, 0.11);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.91, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.925, 0.35);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.94, 0.4);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.945, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.945, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.94, 0.6);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.925, 0.65);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.91, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.88, 0.89);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 1.0);
   rmBuildTradeRoute(tradeRouteID7A, "water");	

   // Text
   rmSetStatusText("",0.35);

// Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 7.0);
   variantChance = rmRandInt(1,2);

   // center route
   if (socketPattern == 1)  // 4 or 6 sockets 
   {
	if (cNumberNonGaiaPlayers > 4)
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.09);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.41);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.59);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.91);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
   else if (socketPattern == 2)  // 3 or 5 sockets 
   {
	if (cNumberNonGaiaPlayers > 3)
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.31);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.69);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.18);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.82);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   twoChoice = rmRandInt(1,2);
   int socketNum = 1;
   if (cNumberNonGaiaPlayers > 4)
	socketNum = 2;
   if (cNumberNonGaiaPlayers == 4)
   {
	if (twoChoice == 2)
   	   socketNum = 2;
   }

   // end routes
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7);
   if (socketNum == 1) // 1 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 2 per route
   { 
	if (socketPattern == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7A);
   if (socketNum == 1) // 1 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 2 per route
   { 
	if (socketPattern == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   //Text
   rmSetStatusText("",0.40);

// Starting TCs and units 	
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);
   rmAddObjectDefConstraint(startingUnits, avoidWater10);

   int startingTCID= rmCreateObjectDef("startingTC");
   rmSetObjectDefMaxDistance(startingTCID, 18.0);
   rmAddObjectDefConstraint(startingTCID, avoidAll);
   rmAddObjectDefConstraint(startingTCID, avoidWater20);
   rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
   rmAddObjectDefConstraint(startingTCID, longAvoidImpassableLand );                
   if ( rmGetNomadStart())
   {
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
   }

   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Central features & patches, per map or variant
   // Center area
   int centerArea=rmCreateArea("TheCenter");
   rmSetAreaSize(centerArea, 0.24, 0.24);
   rmSetAreaLocation(centerArea, 0.5, 0.5);
   rmSetAreaCoherence(centerArea, 0.9);
   rmAddAreaInfluenceSegment(centerArea, 0.5, 0.0, 0.5, 1.0);
   rmAddAreaToClass(centerArea, rmClassID("center")); 
   rmBuildArea(centerArea);

// KOTH game mode 
   if(rmGetIsKOTH())
   {
      float xLoc = 0.52;
	if (KOTHposition == 1)
	   xLoc = 0.48;
      float yLoc = 0.5;
      float walk = 0.04;
    
      ypKingsHillLandfill(xLoc, yLoc, .0075, 2.0, baseType, 0);
      ypKingsHillPlacer(xLoc, yLoc, walk, 0);
   }

   // Text
   rmSetStatusText("",0.45);

// NATIVES
   // Village A - random choice
   int villageAID = -1;
   int whichNative = rmRandInt(1,2);
   int villageType = rmRandInt(1,5);

   if (whichNative == 1)
      villageAID = rmCreateGrouping("village A", native1Name+villageType);
   else if (whichNative == 2)
	villageAID = rmCreateGrouping("village A", native2Name+villageType);
   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageAID, 0.0);
   rmSetGroupingMaxDistance(villageAID, size*0.12);
   rmAddGroupingConstraint(villageAID, avoidAll);
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidWater10);
   rmAddGroupingConstraint(villageAID, avoidNativesMed);
   rmAddGroupingConstraint(villageAID, playerConstraint);

   // Village D - always different type from A 
   int villageDID = -1;
   villageType = rmRandInt(1,5); 

   if (whichNative == 2)
      villageDID = rmCreateGrouping("village D", native1Name+villageType);
   else if (whichNative == 1)
      villageDID = rmCreateGrouping("village D", native2Name+villageType);
   rmAddGroupingToClass(villageDID, rmClassID("natives"));
   rmAddGroupingToClass(villageDID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageDID, 0.0);
   rmSetGroupingMaxDistance(villageDID, size*0.1);
   rmAddGroupingConstraint(villageDID, avoidAll);
   rmAddGroupingConstraint(villageDID, avoidImpassableLand);
   rmAddGroupingConstraint(villageDID, avoidTradeRoute);
   rmAddGroupingConstraint(villageDID, avoidWater10);
   rmAddGroupingConstraint(villageDID, avoidNativesMed);
   rmAddGroupingConstraint(villageDID, playerConstraint);

   // Village B - random choice
   int villageBID = -1;	
   villageType = rmRandInt(1,5); 
   whichNative = rmRandInt(1,2);

   if (whichNative == 1)
      villageBID = rmCreateGrouping("village B", native1Name+villageType);
   else if (whichNative == 2)
	villageBID = rmCreateGrouping("village B", native2Name+villageType);
   rmAddGroupingToClass(villageBID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageBID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageBID, 0.0);
   rmSetGroupingMaxDistance(villageBID, size*0.1);
   rmAddGroupingConstraint(villageBID, avoidAll);
   rmAddGroupingConstraint(villageBID, avoidImpassableLand);
   rmAddGroupingConstraint(villageBID, avoidTradeRoute);
   rmAddGroupingConstraint(villageBID, avoidWater15);
   rmAddGroupingConstraint(villageBID, avoidNatives);
   rmAddGroupingConstraint(villageBID, playerConstraint);

   // Village C - appears in center, random choice
   int villageCID = -1;	
   villageType = rmRandInt(1,5); 
   whichNative = rmRandInt(1,2);

   if (whichNative == 2)
      villageCID = rmCreateGrouping("village C", native1Name+villageType);
   else if (whichNative == 1)
	villageCID = rmCreateGrouping("village C", native2Name+villageType);
   rmAddGroupingToClass(villageCID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageCID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageCID, 0.0);
   rmSetGroupingMaxDistance(villageCID, size*0.1);
   rmAddGroupingConstraint(villageCID, avoidAll);
   rmAddGroupingConstraint(villageCID, avoidImpassableLand);
   rmAddGroupingConstraint(villageCID, avoidWater10);
   rmAddGroupingConstraint(villageCID, avoidTradeRoute);
   rmAddGroupingConstraint(villageCID, avoidNatives);
   rmAddGroupingConstraint(villageCID, playerConstraint);

// Placement of Natives
   if (nativeSetup > 12)  // possible extra native per player
   {
	if (rmRandInt(1,2) == 2)
	{
         for(i=1; <cNumberPlayers) 
         {
            rmSetGroupingMinDistance(villageCID, 65.0);
            rmSetGroupingMaxDistance(villageCID, 90.0);           
	      rmPlaceGroupingAtLoc(villageCID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
         }
	}
   }
   if ((nativeSetup == 13) || (nativeSetup == 17))  
   {
	if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.21);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.21);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.5);
		   }
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.3);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.3);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.5);
		   }
	      }	   
	}
   } 
   else if (nativeSetup == 14)
   {
	if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.3);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.7);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.3);
	      }
	}
   } 
   else if (nativeSetup > 14) // 15 AND 16
   {
	if (nativeSetup == 15)
	{
	   if (axisChance == 1)
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.51);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.49);

         }
	}
	rmAddGroupingConstraint(villageAID, avoidWater20);
	rmAddGroupingConstraint(villageDID, avoidWater20);
	if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	}
	if (rmRandInt(1,3) > 1) // extra possible natives near center
	{
            rmPlaceGroupingAtLoc(villageCID, 0, 0.55, 0.5);
	      rmPlaceGroupingAtLoc(villageCID, 0, 0.45, 0.5); 
      }
	else
	{
	      if (rmRandInt(1,2) == 1)
	      {
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.65);
	   	   rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.35);
	      }
	}
   } 
   else if (nativeSetup < 4)
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.73);
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.27);
         }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.495, 0.82);
            rmPlaceGroupingAtLoc(villageBID, 0, 0.505, 0.18);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.9);
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.10);
	   }
	}

	if (nativeSetup < 2)
	{
         rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.5);
	}
	else 
	{
	   rmSetGroupingMaxDistance(villageCID, size*0.1);
         if (nativeNumber > 2)
	   {
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageCID, 0, 0.465, 0.5);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.535, 0.5);
	      }
	   }
	}
   }
   else if (nativeSetup > 5)
   {
	if (nativeSetup == 7)
	{
         if (axisChance == 1)
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.75); 
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.84); 
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.93); 

	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.25);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.16);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.08);
	   }                
	}
	if (nativeSetup == 8)
	{
   	      rmSetGroupingMaxDistance(villageDID, size*0.1);
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageDID, 0, 0.465, 0.49);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.535, 0.51);
	      }
	}
	if (nativeSetup == 11)
	{
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.5);
               rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.5);
	      }
	}
	if (nativeSetup == 12)
	{
	   if (axisChance == 1)
	   {
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.41, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.59, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.68);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.32);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.68);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.32);
	      }
	   }
	}
	if ((nativeSetup == 9) || (nativeSetup == 10) || (nativeSetup == 6))
	{
	   if (rmRandInt(1,2) == 1)
            rmPlaceGroupingInArea(villageCID, 0, rmAreaID("TheCenter"), rmRandInt(3,4));
	   else
            rmPlaceGroupingInArea(villageCID, 0, rmAreaID("TheCenter"), 2);
	}
      for(i=1; <cNumberPlayers) 
      {
         rmSetGroupingMinDistance(villageAID, 65.0);
         rmSetGroupingMaxDistance(villageAID, 90.0);           
	   rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   if (nativeSetup == 9)
	   {
            rmSetGroupingMinDistance(villageDID, 65.0);
            rmSetGroupingMaxDistance(villageDID, 90.0);      
		rmPlaceGroupingAtLoc(villageDID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   }
	   if (nativeSetup == 10)
		rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      }
   }
   else if (nativeSetup > 3) // setup 4 and 5
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.75);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.25);
	   }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.84);
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.16);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.91);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.09);
	   }
	}          
         
	if (nativeSetup == 4)
	{
	   if (axisChance == 1)
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.415, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.585, 0.5);
         }
	   if (rmRandInt(1,3) == 1) // extra possible natives ends or sides
	   {
            rmPlaceGroupingAtLoc(villageCID, 0, 0.86, 0.47);
	      rmPlaceGroupingAtLoc(villageCID, 0, 0.14, 0.53);
         }
	   else
	   {
	      if (rmRandInt(1,2) == 1)
	      {
               rmPlaceGroupingAtLoc(villageCID, 0, 0.72, 0.5);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.28, 0.5);
	      }
	   }
	}
	if (nativeSetup == 5)
	{	
   	   rmSetGroupingMaxDistance(villageDID, size*0.1);
         if (axisChance == 1)
	   {
            if (sidePosition == 1)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.7, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.3, 0.5);
	      }
	      else if (sidePosition == 2)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.74, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.26, 0.5);
	      }
	      else
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.78, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.22, 0.5);
		}
         }

	   if (rmRandInt(1,3) == 1) // extra possible natives near center
	   {
            rmPlaceGroupingAtLoc(villageCID, 0, 0.55, 0.5);
	      rmPlaceGroupingAtLoc(villageCID, 0, 0.45, 0.5); 
         }
	   else
	   {
	      if (rmRandInt(1,2) == 1)
	      {
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.65);
	   	   rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.35);
	      }
	   }
	}  
   }

   // Text
   rmSetStatusText("",0.50);

// Player Nuggets
   int playerNuggetID=rmCreateObjectDef("player nugget");
   rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
   rmAddObjectDefToClass(playerNuggetID, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(playerNuggetID, 35.0);
   rmSetObjectDefMaxDistance(playerNuggetID, 45.0);
   rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
   rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
   rmAddObjectDefConstraint(playerNuggetID, avoidWater10);
   for(i=1; <cNumberPlayers)
   {
 	rmSetNuggetDifficulty(1, 1);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Cliffs
   int cliffHt = -1;
   int failCount=0;
   if (makeCliffs == 1)
   { 
         int numCliffs = cNumberNonGaiaPlayers + rmRandInt(3,4);
	   if (cliffVariety == 2)
		   numCliffs = cNumberNonGaiaPlayers + rmRandInt(4,7);
	   else if (cliffVariety == 10)
	      numCliffs = 8 + cNumberNonGaiaPlayers*2;
         for (i=0; <numCliffs)
         {
		cliffHt = rmRandInt(5,7);    
		int bigCliffID=rmCreateArea("big cliff" +i);
		rmSetAreaWarnFailure(bigCliffID, false);
		rmSetAreaCliffType(bigCliffID, cliffType);
		rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		if (cliffVariety == 1) // like Patagonia
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(550), rmAreaTilesToFraction(750));
      	   rmSetAreaCliffEdge(bigCliffID, 2, 0.37, 0.1, 1.0, 0);
      	   rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 0.5);
		   rmSetAreaCoherence(bigCliffID, 0.6);
		   rmSetAreaSmoothDistance(bigCliffID, 5);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		else if (cliffVariety == 2) // smaller, kinda like in Sudden Death from AOM
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(280), rmAreaTilesToFraction(400));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.65, 0.1, 1.0, 0);
               rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 1.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 10);
		   rmSetAreaHeightBlend(bigCliffID, 2.0);
		}
		else if (cliffVariety == 10) // Himalaya map
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		   rmSetAreaCliffEdge(bigCliffID, 1, 1.0, 1.0, 0.0, 0);
 		   rmSetAreaCliffPainting(bigCliffID, true, false, true, 0, true);
		   rmSetAreaCliffHeight(bigCliffID, 6, 1.0, 0.3); 
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.8, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 10);
		}
		else  // kinda random, kinda like Texas or NE
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(500));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.55, 0.1, 1.0, 0);
		   rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 15);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		rmSetAreaMinBlobs(bigCliffID, 3);
		rmSetAreaMaxBlobs(bigCliffID, 5);
		rmSetAreaMinBlobDistance(bigCliffID, 5.0);
		rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		rmAddAreaConstraint(bigCliffID, avoidImportantItem);
		rmAddAreaConstraint(bigCliffID, avoidTradeRoute);
            rmAddAreaConstraint(bigCliffID, avoidNatives);
	      rmAddAreaConstraint(bigCliffID, avoidWater20);
	      rmAddAreaConstraint(bigCliffID, cliffsAvoidCliffs);
	      rmAddAreaConstraint(bigCliffID, avoidSocket);
	      rmAddAreaConstraint(bigCliffID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliffID, nuggetPlayerConstraint);
	      rmAddAreaConstraint(bigCliffID, avoidKOTH);
		rmBuildArea(bigCliffID);
         }
   }

   // Text
   rmSetStatusText("",0.55);

// Random Nuggets
   int nugget2= rmCreateObjectDef("nugget medium"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(nugget2, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget2, 60.0);
   rmSetObjectDefMaxDistance(nugget2, 110.0);
   rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget2, avoidSocket);
   rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget2, nuggetPlayerConstraint);
   rmAddObjectDefConstraint(nugget2, avoidNuggetMed);
   rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget2, avoidWater10);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmAddObjectDefConstraint(nugget2, avoidImportantItemSmall);
   rmPlaceObjectDefPerPlayer(nugget2, false, 1);

   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefToClass(nugget3, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget3, 80.0);
   rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.6));
   rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget3, avoidSocket);
   rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget3, farPlayerConstraint);
   rmAddObjectDefConstraint(nugget3, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget3, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget3, avoidWater10);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmAddObjectDefConstraint(nugget3, avoidImportantItemSmall);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   int nugget4= rmCreateObjectDef("nugget nuts"); 
   rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(4, 4);
   rmAddObjectDefToClass(nugget4, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget4, 0.0);
   rmSetObjectDefMaxDistance(nugget4, 4.0);
   rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget4, avoidSocket);
   rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget4, fartherPlayerConstraint);
   rmAddObjectDefConstraint(nugget4, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget4, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget4, avoidWater10);
   rmAddObjectDefConstraint(nugget4, avoidAll);
   rmAddObjectDefConstraint(nugget4, avoidImportantItemSmall);
   rmPlaceObjectDefInArea(nugget4, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers); 

   rmAddObjectDefConstraint(nugget3, fartherPlayerConstraint);
   rmSetNuggetDifficulty(2, 3);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   // Text
   rmSetStatusText("",0.60);

// more resources
   // start area trees 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 12);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false, 3);

   // berry bushes
   int berryNum = rmRandInt(2,5);
   int StartBerryBushID=rmCreateObjectDef("starting berry bush");
   rmAddObjectDefItem(StartBerryBushID, "BerryBush", rmRandInt(2,4), 4.0);
   rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartBerryBushID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(StartBerryBushID, avoidAll);
   if (placeBerries == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);
   if (placeBerries == 1)
   {
      rmPlaceObjectDefInArea(StartBerryBushID, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers); 
      rmPlaceObjectDefInArea(StartBerryBushID, 0, rmAreaID("TheCenter"), 2); 
   }

   // Text
   rmSetStatusText("",0.65);

   // start area huntable
   int deerNum = rmRandInt(5, 8);
   int startPronghornID=rmCreateObjectDef("starting pronghorn");
   rmAddObjectDefItem(startPronghornID, deerType, deerNum, 5.0);
   rmAddObjectDefToClass(startPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(startPronghornID, 16);
   rmSetObjectDefMaxDistance(startPronghornID, 22);
   rmAddObjectDefConstraint(startPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(startPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startPronghornID, avoidAll);
   rmAddObjectDefConstraint(startPronghornID, avoidImportantItemSmall);
   rmSetObjectDefCreateHerd(startPronghornID, true);
   rmPlaceObjectDefPerPlayer(startPronghornID, false, 1);

   // second huntable
   int deer2Num = rmRandInt(4, 8);
   int farPronghornID=rmCreateObjectDef("far pronghorn");
   rmAddObjectDefItem(farPronghornID, deer2Type, deer2Num, 5.0);
   rmAddObjectDefToClass(farPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farPronghornID, 42.0);
   rmSetObjectDefMaxDistance(farPronghornID, 60.0);
   rmAddObjectDefConstraint(farPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(farPronghornID, mediumPlayerConstraint);
   rmAddObjectDefConstraint(farPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(farPronghornID, avoidNativesShort);
   rmAddObjectDefConstraint(farPronghornID, huntableConstraint);
   rmAddObjectDefConstraint(farPronghornID, avoidAll);
   rmAddObjectDefConstraint(farPronghornID, avoidImportantItemSmall);
   rmSetObjectDefCreateHerd(farPronghornID, true);
   if (sheepChance == 0)
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

   // additional second huntable for low player numbers
   if (cNumberNonGaiaPlayers < 4)
   {
      rmAddObjectDefConstraint(farPronghornID, fartherPlayerConstraint);
      rmSetObjectDefMinDistance(farPronghornID, rmXFractionToMeters(0.25));
      rmSetObjectDefMaxDistance(farPronghornID, rmXFractionToMeters(0.38));
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);
   }

// Silver mines - players
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, mineType, 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, avoidSocket);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, avoidWater10);
   rmSetObjectDefMinDistance(playerGoldID, 18.0);
   rmSetObjectDefMaxDistance(playerGoldID, 23.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   rmAddObjectDefConstraint(playerGoldID, playerConstraint);
   rmSetObjectDefMinDistance(playerGoldID, 50.0);
   rmSetObjectDefMaxDistance(playerGoldID, 60.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, mineType, 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, avoidSocket);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldMediumID, farPlayerConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater10);
   rmSetObjectDefMinDistance(GoldMediumID, 85.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 100.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);

   // Text
   rmSetStatusText("",0.70);

// Extra tree clumps near players - to ensure fair access to wood
   int extraTreesID=rmCreateObjectDef("extra trees");
   rmAddObjectDefItem(extraTreesID, treeType, 4, 5.0);
   rmSetObjectDefMinDistance(extraTreesID, 14);
   rmSetObjectDefMaxDistance(extraTreesID, 18);
   rmAddObjectDefConstraint(extraTreesID, avoidAll);
   rmAddObjectDefConstraint(extraTreesID, avoidCoin);
   rmAddObjectDefConstraint(extraTreesID, avoidSocket);
   rmAddObjectDefConstraint(extraTreesID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTreesID, 0, rmAreaID("player"+i), 1);

   int extraTrees2ID=rmCreateObjectDef("more extra trees");
   rmAddObjectDefItem(extraTrees2ID, treeType, 5, 6.0);
   rmSetObjectDefMinDistance(extraTrees2ID, 18);
   rmSetObjectDefMaxDistance(extraTrees2ID, 28);
   rmAddObjectDefConstraint(extraTrees2ID, avoidAll);
   rmAddObjectDefConstraint(extraTrees2ID, avoidCoin);
   rmAddObjectDefConstraint(extraTrees2ID, avoidSocket);
   rmAddObjectDefConstraint(extraTrees2ID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTrees2ID, 0, rmAreaID("player"+i), 2);

// Extra silver mines - more central.
   silverType = rmRandInt(1,10);
   int extraGoldID = rmCreateObjectDef("extra silver "+i);
   if (placeGold == 5)	
      rmAddObjectDefItem(extraGoldID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(extraGoldID, mineType, 1, 0.0);
   rmAddObjectDefToClass(extraGoldID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraGoldID, avoidSocket);
   rmAddObjectDefConstraint(extraGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(extraGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraGoldID, avoidWater10);
   rmAddObjectDefConstraint(extraGoldID, avoidAll);
   rmSetObjectDefMinDistance(extraGoldID, 0.0);
   rmSetObjectDefMaxDistance(extraGoldID, 80.0);
   rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("TheCenter"), rmRandInt(4,5)); 
   if (cNumberNonGaiaPlayers > 4)
	rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("TheCenter"), 2);     

   silverType = rmRandInt(1,10);
   int GoldFarID=rmCreateObjectDef("player silver far");
   if (placeGold == 1)
      rmAddObjectDefItem(GoldFarID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(GoldFarID, mineType, 1, 0.0);
   rmAddObjectDefConstraint(GoldFarID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldFarID, avoidSocket);
   rmAddObjectDefConstraint(GoldFarID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldFarID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldFarID, avoidAll);
   rmAddObjectDefConstraint(GoldFarID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(GoldFarID, centerConstraintFar);
   rmAddObjectDefConstraint(GoldFarID, avoidWater10);
   rmSetObjectDefMinDistance(GoldFarID, 125.0);
   rmSetObjectDefMaxDistance(GoldFarID, 170.0);
   rmPlaceObjectDefPerPlayer(GoldFarID, false, 1);

   // Text
   rmSetStatusText("",0.75);

// Main forests
   int forestChance = -1;
   int numFor=19*cNumberNonGaiaPlayers;
   if (cNumberNonGaiaPlayers > 3)
      numFor=17*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 5)
      numFor=14*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 7)
      numFor=12*cNumberNonGaiaPlayers;    

   failCount=0;
   for (i=0; <numFor)
   {
      forestChance = rmRandInt(1,4);
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
	if (dualForest == 1)
	{
	   if (rmRandInt(1,2) == 1)
		rmSetAreaForestType(forest, forestType);
	   else
		rmSetAreaForestType(forest, forest2Type);
	}
	else
         rmSetAreaForestType(forest, forestType);
      rmSetAreaForestDensity(forest, rmRandFloat(0.7, 1.0));
      rmSetAreaForestClumpiness(forest, rmRandFloat(0.5, 0.9));
      rmSetAreaForestUnderbrush(forest, rmRandFloat(0.0, 0.5));
      rmSetAreaCoherence(forest, rmRandFloat(0.4, 0.7));
      rmSetAreaSmoothDistance(forest, rmRandInt(10,20));
      if (forestChance == 3)
      {
		rmSetAreaMinBlobs(forest, 1);
		rmSetAreaMaxBlobs(forest, 3);					
		rmSetAreaMinBlobDistance(forest, 12.0);
		rmSetAreaMaxBlobDistance(forest, 24.0);
	}
      if (forestChance == 4)
      {
		rmSetAreaMinBlobs(forest, 3);
		rmSetAreaMaxBlobs(forest, 5);					
		rmSetAreaMinBlobDistance(forest, 16.0);
		rmSetAreaMaxBlobDistance(forest, 28.0);
		rmSetAreaSmoothDistance(forest, 120);
	}
      rmAddAreaToClass(forest, rmClassID("classForest")); 
	rmAddAreaConstraint(forest, mediumPlayerConstraint);
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll); 
      rmAddAreaConstraint(forest, avoidImportantItemSmall); 
	rmAddAreaConstraint(forest, avoidCoin);  
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidStartingUnits);
	rmAddAreaConstraint(forest, avoidSocket);
	rmAddAreaConstraint(forest, avoidNativesShort);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   } 

   // Text
   rmSetStatusText("",0.80);

// sheep etc
   int sheepID=rmCreateObjectDef("herdable animal");
   rmAddObjectDefItem(sheepID, sheepType, 2, 4.0);
   rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
   rmSetObjectDefMinDistance(sheepID, 40.0);
   rmSetObjectDefMaxDistance(sheepID, 0.25*longSide);
   rmAddObjectDefConstraint(sheepID, avoidSheep);
   rmAddObjectDefConstraint(sheepID, avoidAll);
   rmAddObjectDefConstraint(sheepID, playerConstraint);
   rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
   rmPlaceObjectDefPerPlayer(sheepID, false, 2);

   rmSetObjectDefMinDistance(sheepID, 75.0);
   rmPlaceObjectDefPerPlayer(sheepID, false, 1);
   if (rmRandInt(1,2) == 1)
      rmPlaceObjectDefPerPlayer(sheepID, false, 1);

   rmAddObjectDefConstraint(sheepID, avoidCliffs);
   rmAddObjectDefConstraint(sheepID, farPlayerConstraint);
   rmSetObjectDefMinDistance(sheepID, 0.0);
   rmSetObjectDefMaxDistance(sheepID, 0.05*size);
   rmPlaceObjectDefInArea(sheepID, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers*2); 


   // Text
   rmSetStatusText("",0.85);

// Central herds
   int centralHerdID=rmCreateObjectDef("central herd");  
   rmAddObjectDefItem(centralHerdID, centerHerdType, rmRandInt(7,9), 6.0);
   rmAddObjectDefToClass(centralHerdID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(centralHerdID, 0.0);
   rmSetObjectDefMaxDistance(centralHerdID, 0.05*size);
   rmAddObjectDefConstraint(centralHerdID, avoidTradeRoute);
   rmAddObjectDefConstraint(centralHerdID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(centralHerdID, avoidWater10);
   rmAddObjectDefConstraint(centralHerdID, farPlayerConstraint);
   rmAddObjectDefConstraint(centralHerdID, longHuntableConstraint);
   rmSetObjectDefCreateHerd(centralHerdID, true);
   rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("TheCenter"), rmRandInt(2,3)); 

   // additional of central herd type
   rmAddObjectDefConstraint(centralHerdID, fartherPlayerConstraint);
   rmSetObjectDefMinDistance(centralHerdID, 0.15*size);
   rmSetObjectDefMaxDistance(centralHerdID, 0.35*size);
   rmPlaceObjectDefAtLoc(centralHerdID, 0, 0.5, 0.5, 0.5*cNumberNonGaiaPlayers);

// far huntable
   int farHuntableID=rmCreateObjectDef("far huntable");
   rmAddObjectDefItem(farHuntableID, deerType, rmRandInt(5,9), 6.0);
   rmAddObjectDefToClass(farHuntableID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farHuntableID, 0.2*size);
   rmSetObjectDefMaxDistance(farHuntableID, 0.3*size);
   rmAddObjectDefConstraint(farHuntableID, avoidTradeRoute);
   rmAddObjectDefConstraint(farHuntableID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(farHuntableID, avoidWater10);
   rmAddObjectDefConstraint(farHuntableID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(farHuntableID, longHuntableConstraint);
   rmAddObjectDefConstraint(farHuntableID, avoidAll);
   rmSetObjectDefCreateHerd(farHuntableID, true);
   rmPlaceObjectDefPerPlayer(farHuntableID, false, 1);

// Lone elk
   int loneElkID=rmCreateObjectDef("lone elk");
   threeChoice = rmRandInt(1,3);
   if (threeChoice == 1)
      rmAddObjectDefItem(loneElkID, centerHerdType, rmRandInt(1,2), 3.0);
   else if (threeChoice == 2)
      rmAddObjectDefItem(loneElkID, deer2Type, rmRandInt(1,2), 3.0);
   else
      rmAddObjectDefItem(loneElkID, deerType, rmRandInt(1,2), 3.0);
   rmAddObjectDefToClass(loneElkID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(loneElkID, 70.0);
   rmSetObjectDefMaxDistance(loneElkID, 0.4*size);
   rmAddObjectDefConstraint(loneElkID, longPlayerConstraint);
   rmAddObjectDefConstraint(loneElkID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(loneElkID, avoidNativesShort);
   rmAddObjectDefConstraint(loneElkID, huntableConstraint);
   rmAddObjectDefConstraint(loneElkID, avoidAll);
   rmSetObjectDefCreateHerd(loneElkID, true);
   rmPlaceObjectDefPerPlayer(loneElkID, false, 2);

   // Text
   rmSetStatusText("",0.90);

// Random trees
   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, treeType, 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmAddObjectDefConstraint(StragglerTreeID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(StragglerTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StragglerTreeID, avoidCoin);
   rmAddObjectDefConstraint(StragglerTreeID, patchConstraint);
   rmAddObjectDefConstraint(StragglerTreeID, avoidWater10);
   rmSetObjectDefMinDistance(StragglerTreeID, 10.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <cNumberNonGaiaPlayers*10)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);

   rmSetObjectDefMaxDistance(StragglerTreeID, 0.5*size);
   for(i=0; <cNumberNonGaiaPlayers*18)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);

// Deco
   // Patches using mixes
   if (makePatchMix == 1)
   {
      for (i=0; <cNumberNonGaiaPlayers*8)   
      {
	   int colorPatch=rmCreateArea("color patch "+i);
	   rmSetAreaWarnFailure(colorPatch, false);
	   rmSetAreaSize(colorPatch, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
         rmSetAreaMix(colorPatch, patchMixType);
	   rmAddAreaToClass(colorPatch, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(colorPatch, 1);
	   rmSetAreaMaxBlobs(colorPatch, 5);
	   rmSetAreaMinBlobDistance(colorPatch, 16.0);
	   rmSetAreaMaxBlobDistance(colorPatch, 36.0);
	   rmSetAreaCoherence(colorPatch, 0.1);
	   rmSetAreaSmoothDistance(colorPatch, 10);
	   rmAddAreaConstraint(colorPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(colorPatch, patchConstraint);
	   rmAddAreaConstraint(colorPatch, avoidWater20);
	   rmAddAreaConstraint(colorPatch, shortForestConstraint);
	   rmBuildArea(colorPatch); 
      }

      for (i=0; <cNumberNonGaiaPlayers*12)   
      {
	   int colorPatch2=rmCreateArea("2nd color patch "+i);
	   rmSetAreaWarnFailure(colorPatch2, false);
	   rmSetAreaSize(colorPatch2, rmAreaTilesToFraction(60), rmAreaTilesToFraction(150));
         rmSetAreaMix(colorPatch2, patchMixType);
	   rmAddAreaToClass(colorPatch2, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(colorPatch2, 1);
	   rmSetAreaMaxBlobs(colorPatch2, 3);
	   rmSetAreaMinBlobDistance(colorPatch2, 10.0);
	   rmSetAreaMaxBlobDistance(colorPatch2, 20.0);
	   rmSetAreaCoherence(colorPatch2, 0.1);
	   rmSetAreaSmoothDistance(colorPatch2, 10);
	   rmAddAreaConstraint(colorPatch2, shortAvoidImpassableLand);
	   rmAddAreaConstraint(colorPatch2, patchConstraint);
	   rmAddAreaConstraint(colorPatch2, avoidWater10);
	   rmAddAreaConstraint(colorPatch2, shortForestConstraint);
	   rmBuildArea(colorPatch2); 
      }
   }

   if (eagles == 1)
   {
	int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
	rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
      rmAddObjectDefToClass(randomEagleTreeID, rmClassID("allProps"));
	rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomEagleTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAll);
	rmAddObjectDefConstraint(randomEagleTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomEagleTreeID, avoidWater10);
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAllProps);
      rmAddObjectDefConstraint(randomEagleTreeID, avoidImportantItem);
      rmAddObjectDefConstraint(randomEagleTreeID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 3);
   }

   if (kingfishers == 1)
   { 
      int specialProp2ID=rmCreateObjectDef("kingfisher prop");
      rmAddObjectDefItem(specialProp2ID, "PropKingfisher", 1, 0.0);
      rmAddObjectDefToClass(specialProp2ID, rmClassID("allProps"));
      rmSetObjectDefMinDistance(specialProp2ID, 0.0);
      rmSetObjectDefMaxDistance(specialProp2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(specialProp2ID, avoidAll);
      rmAddObjectDefConstraint(specialProp2ID, avoidSocket);
      rmAddObjectDefConstraint(specialProp2ID, avoidTradeRoute);
      rmAddObjectDefConstraint(specialProp2ID, avoidAllProps);
      rmAddObjectDefConstraint(specialProp2ID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(specialProp2ID, avoidWater10);
      rmAddObjectDefConstraint(specialProp2ID, avoidImportantItem);
      rmAddObjectDefConstraint(specialProp2ID, longPlayerConstraint);
      rmPlaceObjectDefAtLoc(specialProp2ID, 0, 0.5, 0.5, rmRandInt(2,3));
   }
}